qlserver 6.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207
  1. #!/bin/bash
  2. # Project: Game Server Managers - LinuxGSM
  3. # Author: Daniel Gibbs
  4. # License: MIT License, Copyright (c) 2016 Daniel Gibbs
  5. # Purpose: Quake Live | Server Management Script
  6. # Contributors: https://github.com/GameServerManagers/LinuxGSM/graphs/contributors
  7. # Documentation: https://github.com/GameServerManagers/LinuxGSM/wiki
  8. # Website: https://gameservermanagers.com
  9. # Debugging
  10. if [ -f ".dev-debug" ]; then
  11. exec 5>dev-debug.log
  12. BASH_XTRACEFD="5"
  13. set -x
  14. fi
  15. version="161030"
  16. ##########################
  17. ######## Settings ########
  18. ##########################
  19. #### Server Settings ####
  20. ## Server Start Settings | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters
  21. arch="x64" # x64 or x86
  22. port="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${port}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. ## Server Start Command | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters#additional-parameters
  30. # Edit with care | Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  34. }
  35. #### LinuxGSM Settings ####
  36. ## Notification Alerts
  37. # (on|off)
  38. # Email Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Email
  39. emailalert="off"
  40. email="email@example.com"
  41. emailfrom=""
  42. # Pushbullet Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Pushbullet
  43. pushbulletalert="off"
  44. pushbullettoken="accesstoken"
  45. # Pushbullet Channel | Do not set unless the channel exists on the
  46. # account associated with the access token. Set without using the '#'
  47. # E.g: "thisisachanneltag" would push to #thisisachanneltag
  48. channeltag=""
  49. ## Updating | https://github.com/GameServerManagers/LinuxGSM/wiki/Update
  50. updateonstart="off"
  51. ## Backup | https://github.com/GameServerManagers/LinuxGSM/wiki/Backup
  52. maxbackups="4"
  53. maxbackupdays="30"
  54. stoponbackup="on"
  55. ## Logging | https://github.com/GameServerManagers/LinuxGSM/wiki/Logging
  56. consolelogging="on"
  57. logdays="7"
  58. #### LinuxGSM Advanced Settings ####
  59. ## SteamCMD Settings
  60. # Server appid
  61. appid="349090"
  62. # Steam App Branch Select
  63. # Allows to opt into the various Steam app branches. Default branch is "".
  64. # Example: "-beta latest_experimental"
  65. branch=""
  66. ## Github Branch Select
  67. # Allows for the use of different function files
  68. # from a different repo and/or branch.
  69. githubuser="GameServerManagers"
  70. githubrepo="LinuxGSM"
  71. githubbranch="master"
  72. ## LinuxGSM Server Details
  73. # Do not edit
  74. gamename="Quake Live"
  75. engine="idtech3_ql"
  76. ## Service Name | https://github.com/GameServerManagers/LinuxGSM/wiki/Multiple-Servers
  77. servicename="ql-server"
  78. #### Directories ####
  79. # Edit with care
  80. ## Work Directories
  81. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  82. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  83. lockselfname=".${servicename}.lock"
  84. lgsmdir="${rootdir}/lgsm"
  85. functionsdir="${lgsmdir}/functions"
  86. libdir="${lgsmdir}/lib"
  87. tmpdir="${lgsmdir}/tmp"
  88. filesdir="${rootdir}/serverfiles"
  89. ## Server Specific Directories
  90. systemdir="${filesdir}"
  91. executabledir="${filesdir}"
  92. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  93. servercfg="${servicename}.cfg"
  94. servercfgdefault="server.cfg"
  95. servercfgdir="${filesdir}/baseq3"
  96. servercfgfullpath="${servercfgdir}/${servercfg}"
  97. ## Backup Directory
  98. backupdir="${rootdir}/backups"
  99. ## Logging Directories
  100. gamelogdir="${rootdir}/log/server"
  101. scriptlogdir="${rootdir}/log/script"
  102. consolelogdir="${rootdir}/log/console"
  103. gamelog="${gamelogdir}/${servicename}-game.log"
  104. scriptlog="${scriptlogdir}/${servicename}-script.log"
  105. consolelog="${consolelogdir}/${servicename}-console.log"
  106. emaillog="${scriptlogdir}/${servicename}-email.log"
  107. ## Logs Naming
  108. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%Y-%m-%d-%H:%M:%S').log"
  109. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%Y-%m-%d-%H:%M:%S').log"
  110. ########################
  111. ######## Script ########
  112. ###### Do not edit #####
  113. ########################
  114. # Fetches core_dl for file downloads
  115. fn_fetch_core_dl(){
  116. github_file_url_dir="lgsm/functions"
  117. github_file_url_name="${functionfile}"
  118. filedir="${functionsdir}"
  119. filename="${github_file_url_name}"
  120. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  121. # If the file is missing, then download
  122. if [ ! -f "${filedir}/${filename}" ]; then
  123. if [ ! -d "${filedir}" ]; then
  124. mkdir -p "${filedir}"
  125. fi
  126. echo -e " fetching ${filename}...\c"
  127. # Check curl exists and use available path
  128. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  129. for curlcmd in ${curlpaths}
  130. do
  131. if [ -x "${curlcmd}" ]; then
  132. break
  133. fi
  134. done
  135. # If curl exists download file
  136. if [ "$(basename ${curlcmd})" == "curl" ]; then
  137. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  138. if [ $? -ne 0 ]; then
  139. echo -e "\e[0;31mFAIL\e[0m\n"
  140. echo "${curlfetch}"
  141. echo -e "${githuburl}\n"
  142. exit 1
  143. else
  144. echo -e "\e[0;32mOK\e[0m"
  145. fi
  146. else
  147. echo -e "\e[0;31mFAIL\e[0m\n"
  148. echo "Curl is not installed!"
  149. echo -e ""
  150. exit 1
  151. fi
  152. chmod +x "${filedir}/${filename}"
  153. fi
  154. source "${filedir}/${filename}"
  155. }
  156. core_dl.sh(){
  157. # Functions are defined in core_functions.sh.
  158. functionfile="${FUNCNAME}"
  159. fn_fetch_core_dl
  160. }
  161. core_functions.sh(){
  162. # Functions are defined in core_functions.sh.
  163. functionfile="${FUNCNAME}"
  164. fn_fetch_core_dl
  165. }
  166. # Prevent from running this script as root.
  167. if [ "$(whoami)" = "root" ]; then
  168. if [ ! -f "${functionsdir}/core_functions.sh" ]||[ ! -f "${functionsdir}/check_root.sh" ]||[ ! -f "${functionsdir}/core_messages.sh" ]||[ ! -f "${functionsdir}/core_exit.sh" ]; then
  169. echo "[ FAIL ] Do NOT run this script as root!"
  170. exit 1
  171. else
  172. core_functions.sh
  173. check_root.sh
  174. fi
  175. fi
  176. core_dl.sh
  177. core_functions.sh
  178. getopt=$1
  179. core_getopt.sh